{************************************************************************}
{                                                                        }
{   First Cut at an "On Screen Keyboard"                                 }
{   by Steve Leonard                                                     }
{   Compuserve 73557,203                                                 }
{----------------------------------------------------------------------  }
{   Please send any comments, suggestions, or improvements to me.        }
{   Eventually plan to release this as shareware or freeware.            }                         
{                                                                        }
{ NOTES:                                                                 }
{1. It WILL work without the resource - you just won't get an About box  }
{   or File | Exit menu or ICON.                                         }
{                                                                        }
{2. Run this under Windows, then switch to another application and choose}
{   an option like "save as" where you must type in a file name (or any  }
{   text string).                                                        }
{                                                                        }
{3. Then click on this program,type in the name with the mouse, and click}
{   the Enter button. It should send the text to the application waiting }
{   for input.                                                           }
{                                                                        }
{ Will not work unless you come directly from the "other" application,   }
{ where you were positioned in an input dialog box, and this program     }
{ must not be iconized when you jump into it.                            }
{                                                                        }
{ Does anyone know?                                                      }
{    - How to make it work by making the "keyboard" a resource? Can you  }
{      load a resource into a TWindow? (If I make it a dialog instead of }
{      a window, it doesn't grab the handle of the "other" program when  }
{      it gets focused; it sends the message to itself!                  }
{    - How to make it work if it is iconized, and you click on it then   }
{      try to send the input string without first going back to click on }
{      the "other" application.                                          }
{    - How to make it not send the message if the handle does not point  }
{      to an input control?                                              }
{                                                                        }
{ Long live the Mouse !!!!!!!                                            }
{************************************************************************}
(*
{$R sjlkbd.res}
*)
program SJLKBD;

uses WinTypes, WinProcs, WObjects, StdDlgs, strings;
const
  cm_FileExit = 101;
  id_Menu = 171;
  id_icon = 172;

  id_ButA = 100;
  id_ButB = 101;
  id_butC = 102;
  id_butD = 103;
  id_butE = 104;
  id_butF = 105;
  id_butG = 106;
  id_butH = 107;
  id_butI = 108;
  id_butJ = 109;
  id_butK = 110;
  id_butL = 111;
  id_butM = 112;
  id_butN = 113;
  id_butO = 114;
  id_butP = 115;
  id_butQ = 116;
  id_butR = 117;
  id_butS = 118;
  id_butT = 119;
  id_butU = 120;
  id_butV = 121;
  id_butW = 122;
  id_butX = 123;
  id_butY = 124;
  id_butZ = 125;
  id_but1 = 126;
  id_but2 = 127;
  id_but3 = 128;
  id_but4 = 129;
  id_but5 = 130;
  id_but6 = 131;
  id_but7 = 132;
  id_but8 = 133;
  id_but9 = 134;
  id_but0 = 135;
  id_butdash = 136;
  id_butequal = 137;
  id_butbslash = 138;
  id_butcomma = 139;
  id_butdot = 140;
  id_butslash = 141;
  id_butexclam = 142;
  id_butat = 143;
  id_butpound = 144;
  id_butdollar = 145;
  id_butpct = 146;
  id_butcaret = 147;
  id_butand = 148;
  id_butstar = 149;
  id_butlp = 150;
  id_butrp = 151;
  id_butBkSpace = 152;
  id_butcolon = 153;
  id_butsemicolon = 154;
  id_butSpace = 198;
  id_butEnt = 199;
type

  TKbdApp = object(TApplication)
    procedure InitMainWindow; virtual;
 end;

  Pkbdwin = ^Tkbdwin;
  Tkbdwin = object(TWindow)
       Dc       : hdc;
       buffer   : array[0..80] of char;
       mymsg    : string;
       holdwnd  : hwnd;
       holdwnd2 : hwnd;
       abouton  : boolean;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure CMAbout(var Msg: TMessage);
      virtual cm_First + 301;
    procedure JustGotFocus(var msg: TMessage);
      virtual wm_First + wm_setfocus;
    procedure CMFileExit(var Msg: TMessage);
      virtual cm_First + cm_FileExit;
    procedure SendMsg(var msg: TMessage);
     {  virtual cm_First + cm_WindowEdit;}
      virtual id_First + id_ButEnt;

    procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    function GetClassName: PChar; virtual;

    procedure IDButA(var Msg: TMessage);
      virtual id_First + id_ButA;
    procedure IDButB(var Msg: TMessage);
      virtual id_First + id_ButB;
    procedure IDButC(var Msg: TMessage);
      virtual id_First + id_ButC;
    procedure IDButD(var Msg: TMessage);
      virtual id_First + id_ButD;
    procedure IDButE(var Msg: TMessage);
      virtual id_First + id_ButE;
    procedure IDButF(var Msg: TMessage);
      virtual id_First + id_ButF;
    procedure IDButG(var Msg: TMessage);
      virtual id_First + id_ButG;
    procedure IDButH(var Msg: TMessage);
      virtual id_First + id_ButH;
    procedure IDButI(var Msg: TMessage);
      virtual id_First + id_ButI;
    procedure IDButJ(var Msg: TMessage);
      virtual id_First + id_ButJ;
    procedure IDButK(var Msg: TMessage);
      virtual id_First + id_ButK;
    procedure IDButL(var Msg: TMessage);
      virtual id_First + id_ButL;
    procedure IDButM(var Msg: TMessage);
      virtual id_First + id_ButM;
    procedure IDButN(var Msg: TMessage);
      virtual id_First + id_ButN;
    procedure IDButO(var Msg: TMessage);
      virtual id_First + id_ButO;
    procedure IDButP(var Msg: TMessage);
      virtual id_First + id_ButP;
    procedure IDButQ(var Msg: TMessage);
      virtual id_First + id_ButQ;
    procedure IDButR(var Msg: TMessage);
      virtual id_First + id_ButR;
    procedure IDButS(var Msg: TMessage);
      virtual id_First + id_ButS;
    procedure IDButT(var Msg: TMessage);
      virtual id_First + id_ButT;
    procedure IDButU(var Msg: TMessage);
      virtual id_First + id_ButU;
    procedure IDButV(var Msg: TMessage);
      virtual id_First + id_ButV;
    procedure IDButW(var Msg: TMessage);
      virtual id_First + id_ButW;
    procedure IDButX(var Msg: TMessage);
      virtual id_First + id_ButX;
    procedure IDButY(var Msg: TMessage);
      virtual id_First + id_ButY;
    procedure IDButZ(var Msg: TMessage);
      virtual id_First + id_ButZ;
    procedure IDBut1(var Msg: TMessage);
      virtual id_First + id_But1;       
    procedure IDBut2(var Msg: TMessage);
      virtual id_First + id_But2;
    procedure IDBut3(var Msg: TMessage);
      virtual id_First + id_But3;
    procedure IDBut4(var Msg: TMessage);
      virtual id_First + id_But4;
    procedure IDBut5(var Msg: TMessage);
      virtual id_First + id_But5;
    procedure IDBut6(var Msg: TMessage);
      virtual id_First + id_But6;
    procedure IDBut7(var Msg: TMessage);
      virtual id_First + id_But7;
    procedure IDBut8(var Msg: TMessage);
      virtual id_First + id_But8;
    procedure IDBut9(var Msg: TMessage);
      virtual id_First + id_But9;
    procedure IDBut0(var Msg: TMessage);
      virtual id_First + id_But0;
    procedure IDButSpace(var Msg: TMessage);
      virtual id_First + id_ButSpace;
    procedure IDButBkSpace(var Msg: TMessage);
      virtual id_First + id_ButBkSpace;
    procedure IDButBslash(var Msg: TMessage);
      virtual id_First + id_ButBslash;
    procedure IDButColon(var Msg: TMessage);
      virtual id_First + id_ButColon;
    procedure IDButSemiColon(var Msg: TMessage);
      virtual id_First + id_ButSemiColon;
    procedure IDButStar(var Msg: TMessage);
      virtual id_First + id_ButStar;
    procedure IDButSlash(var Msg: TMessage);
      virtual id_First + id_ButSlash;
    procedure IDButdot(var Msg: TMessage);
      virtual id_First + id_ButDot;
    procedure IDButComma(var Msg: TMessage);
      virtual id_First + id_Butcomma;
    procedure newmsg;
  end;

procedure TkbdWin.newmsg;
begin
   dc := getdc(hwindow);
   strpcopy(buffer,mymsg);
   textout(dc,100,1,'                              ',30);
   textout(dc,100,1,buffer,strlen(buffer));
   ReleaseDC(HWindow,DC);
end;
procedure TKbdApp.InitMainWindow;
begin
  MainWindow := New(Pkbdwin, Init(nil, 'OnScnKbd'));
end;

constructor Tkbdwin.Init(AParent: PWindowsObject; ATitle: PChar);
var
  AControl: PControl;
begin
  TWindow.Init(AParent, ATitle);
  with Attr do
  begin
    Menu := LoadMenu(HInstance, PChar(id_Menu));
    X := GetSystemMetrics(sm_CXScreen) div 8;
    Y := GetSystemMetrics(sm_CYScreen) div 8;
    H := 240;
    W := 425;
  Attr.Style := WS_Caption or WS_SysMenu or WS_MinimizeBox;
  end;
  aControl := new(PButton,init(@self,id_but1,'1',5,35,25,25,false));
  aControl := new(PButton,init(@self,id_but2,'2',35,35,25,25,false));
  aControl := new(PButton,init(@self,id_but3,'3',65,35,25,25,false));
  aControl := new(PButton,init(@self,id_but4,'4',95,35,25,25,false));
  aControl := new(PButton,init(@self,id_but5,'5',125,35,25,25,false));
  aControl := new(PButton,init(@self,id_but6,'6',155,35,25,25,false));
  aControl := new(PButton,init(@self,id_but7,'7',185,35,25,25,false));
  aControl := new(PButton,init(@self,id_but8,'8',215,35,25,25,false));
  aControl := new(PButton,init(@self,id_but9,'9',245,35,25,25,false));
  aControl := new(PButton,init(@self,id_but0,'0',275,35,25,25,false));
  aControl := new(PButton,init(@self,id_butstar,'*',305,35,25,25,false));
  aControl := new(PButton,init(@self,id_butBSlash,'\',335,35,25,25,false));
  aControl := new(PButton,init(@self,id_butBkSPACE,'Bk',365,35,25,25,false));
  aControl := new(PButton,init(@self,id_butQ,'Q',20,65,25,25,false));
  aControl := new(PButton,init(@self,id_butW,'W',50,65,25,25,false));
  aControl := new(PButton,init(@self,id_butE,'E',80,65,25,25,false));
  aControl := new(PButton,init(@self,id_butR,'R',110,65,25,25,false));
  aControl := new(PButton,init(@self,id_butT,'T',140,65,25,25,false));
  aControl := new(PButton,init(@self,id_butY,'Y',170,65,25,25,false));
  aControl := new(PButton,init(@self,id_butU,'U',200,65,25,25,false));
  aControl := new(PButton,init(@self,id_butI,'I',230,65,25,25,false));
  aControl := new(PButton,init(@self,id_butO,'O',260,65,25,25,false));
  aControl := new(PButton,init(@self,id_butP,'P',290,65,25,25,false));
  aControl := new(PButton,init(@self,id_butA,'A',35,95,25,25,false));
  aControl := new(PButton,init(@self,id_butS,'S',65,95,25,25,false));
  aControl := new(PButton,init(@self,id_butD,'D',95,95,25,25,false));
  aControl := new(PButton,init(@self,id_butF,'F',125,95,25,25,false));
  aControl := new(PButton,init(@self,id_butG,'G',155,95,25,25,false));
  aControl := new(PButton,init(@self,id_butH,'H',185,95,25,25,false));
  aControl := new(PButton,init(@self,id_butJ,'J',215,95,25,25,false));
  aControl := new(PButton,init(@self,id_butK,'K',245,95,25,25,false));
  aControl := new(PButton,init(@self,id_butL,'L',275,95,25,25,false));
  aControl := new(PButton,init(@self,id_butsemicolon,';',305,95,25,25,false));
  aControl := new(PButton,init(@self,id_butcolon,':',335,95,25,25,false));
  aControl := new(PButton,init(@self,id_butZ,'Z',50,125,25,25,false));
  aControl := new(PButton,init(@self,id_butX,'X',80,125,25,25,false));
  aControl := new(PButton,init(@self,id_butC,'C',110,125,25,25,false));
  aControl := new(PButton,init(@self,id_butV,'V',140,125,25,25,false));
  aControl := new(PButton,init(@self,id_butB,'B',170,125,25,25,false));
  aControl := new(PButton,init(@self,id_butN,'N',200,125,25,25,false));
  aControl := new(PButton,init(@self,id_butM,'M',230,125,25,25,false));
  aControl := new(PButton,init(@self,id_butcomma,',',260,125,25,25,false));
  aControl := new(PButton,init(@self,id_butdot,'.',290,125,25,25,false));
  aControl := new(PButton,init(@self,id_butslash,'/',320,125,25,25,false));
  aControl := new(PButton,init(@self,id_butent,'Enter',365,92,50,30,false));
  aControl := new(PButton,init(@self,id_butSpace,'Space',110,160,180,30,false));
  mymsg    := '';
  abouton  := false;
end;

 { Return window "class" information }

procedure TKbdWin.GetWindowClass(var AWndClass: TWndClass);
begin
  TWindow.GetWindowClass(AWndClass);
  AWndClass.HIcon := LoadIcon(HInstance, PChar(Id_icon));
end;


{ Return window "class" name }

function TKbdWin.GetClassName: PChar;
begin
  GetClassName := 'SJLKBD';
end;

procedure Tkbdwin.SendMsg(var Msg: TMessage);
begin
{strpcopy(buffer,'ABDEFG');}
 if mymsg = '' then
    strpcopy(buffer,' ');
 sendmessage(holdwnd2,wm_settext,0,longint(@buffer[0]));
 setfocus(holdwnd2);

end;

procedure Tkbdwin.JustGotFocus(var Msg: TMessage);
begin
  holdwnd := msg.wparam;
  if not abouton then
  begin
     holdwnd2 := holdwnd;
     mymsg := '';
  end;
end;

procedure TKbdWin.CMFileExit(var Msg: TMessage);
begin
  CloseWindow;
end;

{ Respond to selection of button  }

procedure TKbdWin.IDButA(var Msg: TMessage);
begin
  mymsg := mymsg + 'A';
  newmsg;
end;
procedure TKbdWin.IDButB(var Msg: TMessage);
begin
  mymsg := mymsg + 'B';
  newmsg;
end;
procedure TKbdWin.IDButC(var Msg: TMessage);
begin
  mymsg := mymsg + 'C';
  newmsg;
end;
procedure TKbdWin.IDButD(var Msg: TMessage);
begin
  mymsg := mymsg + 'D';
  newmsg;
end;
procedure TKbdWin.IDButE(var Msg: TMessage);
begin
  mymsg := mymsg + 'E';
  newmsg;
end;
procedure TKbdWin.IDButF(var Msg: TMessage);
begin
  mymsg := mymsg + 'F';
  newmsg;
end;
procedure TKbdWin.IDButG(var Msg: TMessage);
begin
  mymsg := mymsg + 'G';
  newmsg;
end;
procedure TKbdWin.IDButH(var Msg: TMessage);
begin
  mymsg := mymsg + 'H';
  newmsg;
end;
procedure TKbdWin.IDButI(var Msg: TMessage);
begin
  mymsg := mymsg + 'I';
  newmsg;
end;
procedure TKbdWin.IDButJ(var Msg: TMessage);
begin
  mymsg := mymsg + 'J';
  newmsg;
end;
procedure TKbdWin.IDButK(var Msg: TMessage);
begin
  mymsg := mymsg + 'K';
  newmsg;
end;
procedure TKbdWin.IDButL(var Msg: TMessage);
begin
  mymsg := mymsg + 'L';
  newmsg;
end;
procedure TKbdWin.IDButM(var Msg: TMessage);
begin
  mymsg := mymsg + 'M';
  newmsg;
end;
procedure TKbdWin.IDButN(var Msg: TMessage);
begin
  mymsg := mymsg + 'N';
  newmsg;
end;
procedure TKbdWin.IDButO(var Msg: TMessage);
begin
  mymsg := mymsg + 'O';
  newmsg;
end;
procedure TKbdWin.IDButP(var Msg: TMessage);
begin
  mymsg := mymsg + 'P';
  newmsg;
end;
procedure TKbdWin.IDButQ(var Msg: TMessage);
begin
  mymsg := mymsg + 'Q';
  newmsg;
end;
procedure TKbdWin.IDButR(var Msg: TMessage);
begin
  mymsg := mymsg + 'R';
  newmsg;
end;
procedure TKbdWin.IDButS(var Msg: TMessage);
begin
  mymsg := mymsg + 'S';
  newmsg;
end;
procedure TKbdWin.IDButT(var Msg: TMessage);
begin
  mymsg := mymsg + 'T';
  newmsg;
end;
procedure TKbdWin.IDButU(var Msg: TMessage);
begin
  mymsg := mymsg + 'U';
  newmsg;
end;
procedure TKbdWin.IDButV(var Msg: TMessage);
begin
  mymsg := mymsg + 'V';
  newmsg;
end;
procedure TKbdWin.IDButW(var Msg: TMessage);
begin
  mymsg := mymsg + 'W';
  newmsg;
end;
procedure TKbdWin.IDButX(var Msg: TMessage);
begin
  mymsg := mymsg + 'X';
  newmsg;
end;
procedure TKbdWin.IDButY(var Msg: TMessage);
begin
  mymsg := mymsg + 'Y';
  newmsg;
end;
procedure TKbdWin.IDButZ(var Msg: TMessage);
begin
  mymsg := mymsg + 'Z';
  newmsg;
end;
procedure TKbdWin.IDBut1(var Msg: TMessage);
begin
  mymsg := mymsg + '1';
  newmsg;
end;
procedure TKbdWin.IDBut2(var Msg: TMessage);
begin
  mymsg := mymsg + '2';
  newmsg;
end;
procedure TKbdWin.IDBut3(var Msg: TMessage);
begin
  mymsg := mymsg + '3';
  newmsg;
end;
procedure TKbdWin.IDBut4(var Msg: TMessage);
begin
  mymsg := mymsg + '4';
  newmsg;
end;
procedure TKbdWin.IDBut5(var Msg: TMessage);
begin
  mymsg := mymsg + '5';
  newmsg;
end;
procedure TKbdWin.IDBut6(var Msg: TMessage);
begin
  mymsg := mymsg + '6';
  newmsg;
end;
procedure TKbdWin.IDBut7(var Msg: TMessage);
begin
  mymsg := mymsg + '7';
  newmsg;
end;
procedure TKbdWin.IDBut8(var Msg: TMessage);
begin
  mymsg := mymsg + '8';
  newmsg;
end;
procedure TKbdWin.IDBut9(var Msg: TMessage);
begin
  mymsg := mymsg + '9';
  newmsg;
end;
procedure TKbdWin.IDBut0(var Msg: TMessage);
begin
  mymsg := mymsg + '0';
  newmsg;
end;
procedure TKbdWin.IDButSpace(var Msg: TMessage);
begin
  mymsg := mymsg + ' ';
  newmsg;
end;
procedure TKbdWin.IDButBSlash(var Msg: TMessage);
begin
  mymsg := mymsg + '\';
  newmsg;
end;
procedure TKbdWin.IDButBkSpace(var Msg: TMessage);
begin
  mymsg := copy(mymsg,1,length(mymsg)-1);
  newmsg;
end;
procedure TKbdWin.IDButColon(var Msg: TMessage);
begin
  mymsg := mymsg + ':';
  newmsg;
end;
procedure TKbdWin.IDButsemiColon(var Msg: TMessage);
begin
  mymsg := mymsg + ';';
  newmsg;
end;

procedure TKbdWin.IDButStar(var Msg: TMessage);
begin
  mymsg := mymsg + '*';
  newmsg;
end;
procedure TKbdWin.IDButslash(var Msg: TMessage);
begin
  mymsg := mymsg + '/';
  newmsg;
end;
procedure TKbdWin.IDButcomma(var Msg: TMessage);
begin
  mymsg := mymsg + ',';
  newmsg;
end;
procedure TKbdWin.IDButdot(var Msg: TMessage);
begin
  mymsg := mymsg + '.';
  newmsg;
end;

procedure TKbdWin.CMAbout(var Msg: TMessage);
var
  Dialog: TDialog;
begin
  abouton := true; 
  Dialog.Init(@Self, 'About');
  Dialog.Execute;
  Dialog.Done;
end;

var
  ModalApp: TKbdApp;
begin
  ModalApp.Init('Kbd');
  ModalApp.Run;
  ModalApp.Done;
end.
